<template>
  <form action="#" @submit.prevent="submit">
    <div class="bg-white shadow-md rounded px-8 pt-6 pb-8 mb-4 flex flex-col">
      <div class="mb-4">
        <label class="block text-grey-darker text-sm font-bold mb-2" for="email"> Email </label>
        <input
          class="shadow appearance-none border rounded w-full py-2 px-3 text-grey-darker"
          name="email"
          id="email"
          type="text"
          placeholder="Email"
          v-model="form.email"
        />
      </div>
      <div class="mb-4">
        <label class="block text-grey-darker text-sm font-bold mb-2" for="name"> Pseudo </label>
        <input
          class="shadow appearance-none border rounded w-full py-2 px-3 text-grey-darker"
          name="name"
          id="name"
          type="text"
          placeholder="Pseudo"
          v-model="form.name"
        />
      </div>
      <div class="mb-6">
        <label class="block text-grey-darker text-sm font-bold mb-2" for="password">
          Password
        </label>
        <input
          class="shadow appearance-none border border-red rounded w-full py-2 px-3 text-grey-darker mb-3"
          name="password"
          v-model="form.password"
          id="password"
          type="password"
          placeholder="Mot de passe"
        />
      </div>

      <div class="mb-6">
        <label class="block text-grey-darker text-sm font-bold mb-2" for="formFile">
          Photo de profil
        </label>
        <input
          class="form-control block w-full px-3 py-1.5 text-base font-normal text-gray-700 bg-white bg-clip-padding border border-solid border-gray-300 rounded transition ease-in-out m-0 focus:text-gray-700 focus:bg-white focus:border-blue-600 focus:outline-none"
          type="file"
          id="formFile"
          v-on:change="onFileChange"
        />
      </div>

      <div class="flex items-center justify-center">
        <button
          type="submit"
          class="bg-orange-book hover:bg-orange-book-hover text-white font-bold py-2 px-4 rounded"
        >
          Inscription
        </button>
      </div>
    </div>
  </form>
</template>

<script>
import { signOut, storeImage, signUp } from "../services/authenticationService";
export default {
  name: "SignUp",
  data() {
    return {
      form: {
        name: "",
        email: "",
        password: "",
        img: "",
      },
      error: null,
    };
  },
  methods: {
    async submit() {
      let urlImg = null;
      if (this.form.img) {
        urlImg = await storeImage(this.form.img);
      }

      let connection = await signUp(this.form.email, this.form.password, this.form.name, urlImg);
      this.$emit("custom-event-user-regist", { userIsCo: connection });
    },
    onFileChange(e) {
      var files = e.target.files || e.dataTransfer.files;
      if (!files.length) return;
      this.form.img = files[0];
    },
    deco() {
      signOut();
    },
  },
};
</script>
